package edu.berkeley.sbp;
import edu.berkeley.sbp.util.*;
import edu.berkeley.sbp.*;
import edu.berkeley.sbp.*;
import java.io.*;
import java.util.*;
import java.lang.reflect.*;
import java.lang.ref.*;

/** the root superclass for all components of the grammar (terminals, nonterminals, literals, etc) */
public abstract class Element {

    /** add all positions reachable from the start of this Element to @rp */
    abstract void reachable(HashSet<Sequence.Position> rp);

    abstract Topology toAtom();
    public Topology noFollow() { return null; }
    Forest epsilonForm() { throw new Error("no epsilon form: " + this); }
    final boolean possiblyEpsilon(Walk.Cache cache)   {
        Boolean ret = cache==null ? null : cache.possiblyEpsilon.get(this);
        if (ret != null) return ret.booleanValue();
        ret = new Walk.PossiblyEpsilon().walk(this) ? Boolean.TRUE : Boolean.FALSE;
        if (cache != null) cache.possiblyEpsilon.put(this, ret);
        return ret;
    }
}
